'******************************************************************
'Autor: Johann Gerner
'zwei mal 4-stelliger LED Voltmeter Ampermeter
'Stand 4.3.2012
'ToDo: Tempmessung, Messbereichsumschaltung
'
'
'
'Anzeigen mit gemeinsamer Anode an PortB0 bis PortB7 (Segment d an PB0 usw.)
'PB0 -> Segment E
'PB1 -> Segment D
'PB2 -> Segment Dezimalpunkt
'PB3 -> Segment C
'PB4 -> Segment G
'PB5 -> Segment B
'PB6 -> Segment A
'PB7 -> Segment F

'Digitansteuerung ber 8 PNP Transistoren ber PD0 bis PD7
'Zuordnung im Case ...

'Ad-Wandler und Schaltausgnge
'PC0 -> ADWandler fr Spannungsmessung
'PC1 -> ADWandler fr Strommessung
'PC2 -> ADWandler fr Temperaturmessung
'PC3 -> Schaltausgang Relais "Trafoumschaltung"
'PC4 -> Schaltausgang Lfter
'PC5 -> Schaltausgang Mess-Bereichsumschaltung Spannungsmessung


$regfile = "m8def.dat"
'interner RC: 8 MHz
$crystal = 8000000

'AD Converter initialisieren
Config Adc = Single , Prescaler = 128 , Reference = Avcc    'Externe Ref: 4,096V
Start Adc

Dim Adwert1 As Word , Adwert2 As Word , Adwert3 As Word     'ausgelesene ADC Kanle
Dim Summe_u As Dword , Summe_i As Dword                     'Aufsummierte Ergebnisse
Dim Dummy As Dword
Dim Refspannung As Word
Dim Kommastelle_u As Byte , Kommastelle_a As Byte
Dim J As Byte , I As Byte                                   'Schleifenzhler

Dim Trafo_s1 As Word , Trafo_s2 As Word                     'Trafoumschalt- und Zurckschaltspannung


' variablen fr die display routine
Dim Tempstr As String * 8
Dim Y As Byte
Dim Tempbyte As Byte
' Variable fr Digitansteuerung
Dim Digit As Byte
'Anzeige im Ganzen
Dim Acht_digit As String * 8
Dim S1 As String * 4 , S2 As String * 4
Dim Umdreh As Byte

Dim Menumodus As Byte
Dim V_kor As Single , A_kor As Single , Ref_kor As Single   'je 4 byte im eeprom
Dim Tc As Byte , Us As Byte

Dim Sreal As Single                                         'Zur Korrekturwertberechung

'Setze PD0-PD7  sowie PB0-PB7 auf Ausgang
Ddrd = &B11111111
Ddrb = &B11111111
'Setzte PC0-PC2 auf Eingang und Rest aus Ausgang
Ddrc = &B11111000

'PortB alle Mann auf Ausgang
'Config Portb = Output
'alle Segmente aus
Portb = 255

'fr Tastenabfrage vorbereiten
'Ddrd = &B01110111
Config Portd.4 = Input
Config Portd.5 = Input
Portd.4 = 1                                                 'Pullup aktivieren
Portd.5 = 1

'Alias fr Steuerports
Relais_port Alias Portc.3
Luefter_port Alias Portc.4
Spannungsteiler Alias Portc.5

Menumodus = 0
'Korrekturwerte werden aus dem EEPROM gelesen
Readeeprom V_kor , 1
Readeeprom A_kor , 6
Readeeprom Tc , 12
Readeeprom Us , 14

'config portc.3 = output
'Relais_port = 1

'wartet nach Reset ob in den Menumodus gewechselt wird "Taster 1"
For I = 1 To 100
Debounce Pind.4 , 0 , Moduswechsel , Sub
Waitms 10
Next I

'Multiplikationsfaktor fr Spannung und Strom, qasi der "Mastab"
If V_kor < 0.2 Then V_kor = 1                               'Vorgabewert auf Multiplikationsfaktor 1 setzen
If V_kor >= 5 Then V_kor = 1

If A_kor < 0.2 Then A_kor = 1
If A_kor >= 5 Then A_kor = 1

If Tc = 255 Then Tc = 70                                    'Vorgabewert 70 Grad C wenn EEprom neu
If Us = 255 Then Us = 10                                    'Vorgabewert 10 Volt fr Umschaltung wenn EEprom neu


'Spannungswert liegt im 10mV Einheiten vor
Trafo_s1 = Us * 100                                         'Spannunswert fr die Trafoumschaltung
Trafo_s2 = Trafo_s1 + 100                                   'Hysteresewert von 1 Volt

'temp_s =

'**********************Hauptschleife************************
Do                                                          'Hauptschleife
   'Abfrage der Eingabetasten wenn der Menmodus aktiv ist
   If Menumodus > 0 Then
      Debounce Pind.4 , 0 , Up , Sub                        'Abfrage Taster 1
      Debounce Pind.5 , 0 , Menu , Sub                      'Abfrage Taster 2
   Else
     Ddrd = &B11111111                                      'zwei Ports im Eingabemodus auf Ausgabe zurcksetzen
   End If

   'Formatiere das Display
   S1 = Format(s1 , "0000")
   S2 = Format(s2 , "0000")
   Acht_digit = S1 + S2                                     'S1 und S2 werden vereint
'   Acht_digit = "12345678"

   Kommastelle_u = 1
   Kommastelle_a = 4

   '' ************ Start vom DISPLAY CODE

   ' jeder Lauf durch die Hauptschleife zeigt ein anderes Digit
   Incr Digit
   Waitms 2                                                 'Zeit fr die Anzeige (je lnger wait desto mehr flackert es)
    If Digit = 8 Then                                       ' mache das , bis 8 erreicht ist
      Digit = 0
      Gosub Admessung                                       'Springe ins Unterprg zum Messsen
    End If

   ' addiere 1 zum Digitcounter, weil MID 1-basiert ist
   Y = Digit + 1
   ' und hol das Digit, das wir brauchen
   Tempstr = Mid(acht_digit , Y , 1)


  Select Case Digit
   Case 4 : Portd = &B11111110                              ' je nach Design des Boards kann hier
   Case 3 : Portd = &B11111101                              ' die Zuordnung gendert werden
   Case 2 : Portd = &B11111011
   Case 1 : Portd = &B11110111
   Case 0 : Portd = &B11101111
   Case 7 : Portd = &B11011111
   Case 6 : Portd = &B10111111
   Case 5 : Portd = &B01111111
  End Select

 'Dieser Teil erledigt die Wandlung in 7 Segment Code
  Select Case Val(tempstr)
   Case 0 : Portb = &B00010100                              ' Zahl 1
   Case 1 : Portb = &B11010111                              ' Zahl 2
   Case 2 : Portb = &B10001100                              ' Zahl 3
   Case 3 : Portb = &B10000101                              ' Zahl 4
   Case 4 : Portb = &B01000111                              ' Zahl 5
   Case 5 : Portb = &B00100101                              ' Zahl 6
   Case 6 : Portb = &B00100100                              ' Zahl 7
   Case 7 : Portb = &B10010111                              ' Zahl 8
   Case 8 : Portb = &B00000100                              ' Zahl 9
   Case 9 : Portb = &B00000101                              ' Zahl 0
   Case Else : Portb = &B11111111                           '&B11111111 Alles aus
  End Select

  'Dezimalpunkt anzeigen DP an Portb.2 angeschlossen
  If Kommastelle_u = Digit Then Portb.2 = 0
  If Kommastelle_a = Digit Then Portb.2 = 0

  'Im 4tem Digit ein U fr und im 8 Digit ein A anzeigen
  If Digit = 3 Then Portb = &B01010100                      'U
  If Digit = 7 Then Portb = &B00000110                      'A

   '' ************ ENDE VOM DISPLAY CODE

Loop
'******************** Ende der Hauptschleife *********************

Admessung:
   'Beide Ausgabeports ausschalten damit die AD Wandlung gleichmig abluft
   Portb = 255
   Portd = 255

   'Waitus 200                                               'ADC kann sich ein wenig beruhigen
   Adwert1 = Getadc(0)
   Adwert2 = Getadc(1)
   Adwert3 = Getadc(2)

   Summe_u = Summe_u + Adwert1                              'Aufsummierung der Spannungswert
   Summe_i = Summe_i + Adwert2

   J = J + 1
   If J = 32 Then                                           '32 Werte aufsummieren

    Summe_u = Summe_u / 8
    Sreal = Summe_u                                         'Berchnung der Spannung in V max 40.96V
    Sreal = Sreal * V_kor
    Summe_u = Round(sreal)

    If Summe_u < Trafo_s1 Then Relais_port = 1
    If Summe_u > Trafo_s2 Then Relais_port = 0

'    If Adwert3

    Summe_i = Summe_i / 4                                   'Berechung des Stromes in A  max 8.192A
    Sreal = Summe_i
    Sreal = Sreal * A_kor
    Summe_i = Round(sreal)

    If Menumodus = 0 Then
      S1 = Str(summe_u)
      S2 = Str(summe_i)
    Else
      Gosub Menuanzeige                                     'Anzeige min Kabibriermodus
      S1 = Str(dummy)
      S2 = Str(menumodus)
    End If

    J = 0
    Summe_u = 0
    Summe_i = 0
   End If
Return

Moduswechsel:
      Menumodus = 1
Return

Up:
Select Case Menumodus
   Case 1 : V_kor = V_kor + 0.001                           'Menmodus 1, Korrekturwert um 0.001 erhhen
   Case 2 : V_kor = V_kor - 0.001                           'usw...
   Case 3 : A_kor = A_kor + 0.001
   Case 4 : A_kor = A_kor - 0.001
   Case 5 : Tc = Tc + 1                                     'Lftereinschalttemp um 1 Grad erhhen
   Case 6 : Us = Us + 1                                     'Trafoumschaltspannung um 1 V erhhen
   If Tc > 100 Then Tc = 20
   If Us > 30 Then Us = 5
   End Select
Return

'Menumodus um eins weiterschalten, im Modus 7 die Eingaben abspeichern
Menu:
 Menumodus = Menumodus + 1
 If Menumodus = 7 Then
    Writeeeprom V_kor , 1
    Writeeeprom A_kor , 6
    Writeeeprom Tc , 12
    Writeeeprom Us , 14
 End If
 If Menumodus = 8 Then Menumodus = 1
Return

Menuanzeige:
Select Case Menumodus
  Case 1 : Dummy = Summe_u
  Case 2 : Dummy = Summe_u
  Case 3 : Dummy = Summe_i
  Case 4 : Dummy = Summe_i
  Case 5 : Dummy = Tc
  Case 6 : Dummy = Us
  Case 7 : Dummy = 5555                                     'Soll SSSS darstellen da dann die Daten gespeichert werden
  End Select
Return